import { world, system, BlockPermutation, EntityComponentTypes, EquipmentSlot, ItemStack, BlockTypes, Player } from "@minecraft/server";
import { ActionFormData, ModalFormData, MessageFormData } from "@minecraft/server-ui";

/*
Another Code Not By Me
So Don't Enter In Here
*/

system.beforeEvents.watchdogTerminate.subscribe(eventData => {
  eventData.cancel = true;
});

const achievements = [
  { name: "Getting an Upgrade!", item: "minecraft:stone_pickaxe", requiredAmount: 1, tag: "stone_pickaxe", epic: false },
  { name: "Aquire Hardware!", item: "minecraft:iron_ingot", requiredAmount: 1, tag: "iron_ingot", epic: false },
  { name: "Hot Stuff!", item: "minecraft:lava_bucket", requiredAmount: 1, tag: "lava_bucket", epic: false },
  { name: "Suit Up!", item: "minecraft:iron_chestplate", requiredAmount: 1, tag: "iron_chestplate", epic: false },
  { name: "Isn't It Iron Pick!", item: "minecraft:iron_pickaxe", requiredAmount: 1, tag: "iron_pickaxe", epic: false },
  { name: "Ice Bucket Challenge!", item: "minecraft:obsidian", requiredAmount: 1, tag: "obsidian", epic: false },
  { name: "Diamonds!", item: "minecraft:diamond", requiredAmount: 1, tag: "diamond", epic: false },
  { name: "Cover me with Diamonds!", item: "minecraft:diamond_chestplate", requiredAmount: 1, tag: "diamond_chestplate", epic: true },
  { name: "Enchanter!", item: "minecraft:enchanted_book", requiredAmount: 1, tag: "enchanted_book", epic: false },
  { name: "Zombie Doc!", item: "minecraft:golden_apple", requiredAmount: 1, tag: "golden_apple", epic: true },
  { name: "Eye Spy!", item: "minecraft:ender_eye", requiredAmount: 1, tag: "ender_eye", epic: true },
  { name: "Bee Our Guest!", item: "minecraft:honey_bottle", requiredAmount: 1, tag: "honey_bottle", epic: false },
  { name: "BFF!", item: "minecraft:lead", requiredAmount: 1, tag: "lead", epic: false },
  { name: "Time To Mine", item: "minecraft:wooden_pickaxe", requiredAmount: 1, tag: "wooden_pickaxe", epic: false },
  { name: "Cow Tipper", item: "minecraft:leather", requiredAmount: 1, tag: "leather", epic: false },
  { name: "Into Fire!", item: "minecraft:blaze_rod", requiredAmount: 1, tag: "blaze_rod", epic: true },
  { name: "The Beginning.", item: "minecraft:nether_star", requiredAmount: 1, tag: "nether_star", epic: true },
  { name: "Dragon Egg!", item: "minecraft:dragon_egg", requiredAmount: 1, tag: "dragon_egg", epic: true },
  { name: "Cover Me With Debris", item: "minecraft:netherite_chestplate", requiredAmount: 1, tag: "netherite_chestplate", epic: true },
  { name: "Legendary Weapons: CyclopEye", item: "iceandfire:eye_cyclop", requiredAmount: 1, tag: "cyclop_eye", epic: true },
  { name: "Dragon Of Eye", item: "allainmc:dragon_eye", requiredAmount: 1, tag: "dragon_eye", epic: true },
  { name: "Dragon Bow!!!", item: "iceandfire:dragon_bow", requiredAmount: 1, tag: "dragon_bow", epic: false },
];

const achievementsEntity = [
  { name: "The End?", entity: "minecraft:ender_dragon", tag: "ender_dragonkill", epic: true },
  { name: "Hostile Mobs", entity: "minecraft:zombie", tag: "zombiekill", epic: false },
  { name: "Is That Is A Nether Star?", entity: "minecraft:wither", tag: "witherkill", epic: true },
  { name: "Yoo, You Kill Golem?", entity: "minecraft:iron_golem", tag: "iron_golemkill", epic: false },
  { name: "Ice Dragon Has Been Killed!!", entity: "iceandfire:dragon_ice", tag: "iceDragonkill", epic: true },
  { name: "Fire Dragon Has Been Killed!!!", entity: "iceandfire:dragon_fire", tag: "fireDragonkill", epic: true },
  { name: "Deathworm!!", entity: "iceandfire:deathworm", tag: "deathWormkill", epic: false },
  { name: "Yoo, You Kill A Sea Serpent?", entity: "iceandfire:sea_serpent", tag: "sea_serpentkill", epic: true },
  { name: "Very Beautiful but not friendly", entity: "iceandfire:siren", tag: "sirenKill", epic: false },
  { name: "Shadow Golem!", entity: "shadowboss:golem_shadow", tag: "shadowGolemkill", epic: true },
];

world.afterEvents.playerPlaceBlock.subscribe((data) => {
  let players = world.getPlayers();
  for (let player of players) {
    if (data.block.typeId == "minecraft:carrots" && !player.hasTag("carrots")) {
      player.sendMessage("[§2" + player.nameTag + "§f] Made The Advancement: §aA Seedy Place!");
      player.addTag("carrots");
      player.runCommandAsync("playsound task_achievement @p");
    }
    if (data.block.typeId == "minecraft:crafting_table" && !player.hasTag("craftingTable")) {
      player.sendMessage("[§2" + player.nameTag + "§f] Made The Advancement: §a§aBenchmarking!");
      player.addTag("craftingTable");
      player.runCommandAsync("playsound task_achievement @p");
    }
    if (data.block.typeId == "minecraft:enchanting_table" && !player.hasTag("enchantingTable")) {
      player.sendMessage("[§2" + player.nameTag + "§f] Made The Advancement: §a§aLet's Enchanted!");
      player.addTag("enchantingTable");
      player.runCommandAsync("playsound goal_achievement @p");
    }
  }
});

world.afterEvents.playerBreakBlock.subscribe(({ block, player, brokenBlockPermutation }) => {
  if (brokenBlockPermutation.type.id == "minecraft:stone" && !player.hasTag("stone_age")) {
    player.sendMessage("[§2" + player.nameTag + "§f] Made The Advancement: §a§aStone Age!");
    player.runCommandAsync("playsound task_achievement @p");
    player.addTag("stone_age");
  }
});

system.runInterval(() => {
  for (let player of world.getPlayers()) {
    const inventory = player.getComponent("minecraft:inventory").container;
    if (inventory.size > 0) {
      for (let slot = 0; slot < inventory.size; slot++) {
        let item = inventory.getItem(slot);
        const achievement = achievements.find((ach) =>
          item?.typeId == ach.item &&
          item?.amount >= ach.requiredAmount &&
          !player.hasTag(ach.tag)
        );
        if (achievement) {
          world.sendMessage(
            "[§2" + player.nameTag + "§f] Made The Advancement: " + (achievement.epic ? "§5" : "§e") + achievement.name
          );
          player.runCommandAsync(achievement.epic ? "playsound goal_achievement @p" : "playsound task_achievement @p");
          player.addTag(achievement.tag);
        }
      }
    }
  }
});

world.afterEvents.entityDie.subscribe(data => {
  const damageS = data.damageSource;
  const dead = data.deadEntity;
  for (let player of world.getPlayers()) {
    if (data.damageSource.cause == "entityAttack" && damageS.damagingEntity.typeId == "minecraft:player") {
      const achievementEntity = achievementsEntity.find((ache) =>
        dead?.typeId == ache.entity &&
        !player.hasTag(ache.tag)
      );
      if (achievementEntity) {
        world.sendMessage(
          "[§2" + player.nameTag + "§f] Made The Advancement: " + (achievementEntity.epic ? "§5" : "§e") + achievementEntity.name
        );
        player.runCommandAsync(achievementEntity.epic ? "playsound goal_achievement @p" : "playsound task_achievement @p");
        player.addTag(achievementEntity.tag);
      }
    }
  }
});

let iterator = 1;

world.afterEvents.itemUse.subscribe(result => {
  if (result.itemStack.typeId.includes('allainmc') && result.itemStack.typeId.includes('boomerang')) {
    result.itemStack.getComponent('minecraft:cooldown');
    result.source.runCommandAsync(`execute as @e[family=boomerang,tag=justSpwn] run tag @s add boom_${iterator}`);
    result.source.runCommandAsync(`execute as @s if entity @e[family=boomerang,tag=justSpwn] run tag @s add throwing_${iterator}`);
    result.source.runCommandAsync('execute as @e[family=boomerang,tag=justSpwn] run tag @s remove justSpwn');
    console.warn(iterator);
    iterator = (iterator % 20) + 1;
  }
});

system.runInterval(() => {
  const dimension = world.getDimension('overworld');
  const entities = dimension.getEntities();
  const tags = Array.from({ length: 20 }, (_, i) => `boom_${i + 1}`);
  entities.forEach(e => {
    if (e.hasTag('returning')) {
      e.runCommandAsync('tp @e[type=item,r=3] @s');
      e.runCommandAsync('tp @e[type=xp_orb,r=3] @s');
      tags.forEach(tag => {
        if (e.hasTag(tag)) {
          const tagNumber = tag.slice(5);
          e.runCommandAsync(`event entity @s rev:add_rtrn_${tagNumber}`);
          e.runCommandAsync(`event entity @s rev:tp${tagNumber}`);
        }
      });
    }
  });
}, 1);

function getGameMode(player) {
  const modes = ["adventure", "survival", "creative", "spectator"];
  for (const mode of modes) {
    if (world.getPlayers({ gameMode: mode }).some(p => p.name === player.name)) {
      return mode;
    }
  }
}

function targetActiveInChunk(a, b) {
  return Math.floor(Math.sqrt((a.x - b.x) ** 2 + (a.y - b.y) ** 2 + (a.z - b.z) ** 2));
}

function randomSpawn(entity) {
  const { x: posX, y: posY, z: posZ } = entity.location;
  const random = 1 + Math.floor(Math.random() * 4);
  const dim = world.getDimension("overworld");
  entity.runCommandAsync("gamerule sendcommandfeedback false");
  const tpCoords = [
    [posX + Math.floor(Math.random() * 2000), posZ + Math.floor(Math.random() * 2000)],
    [posX - Math.floor(Math.random() * 2000), posZ + Math.floor(Math.random() * 2000)],
    [posX + Math.floor(Math.random() * 2000), posZ - Math.floor(Math.random() * 2000)],
    [posX - Math.floor(Math.random() * 2000), posZ - Math.floor(Math.random() * 2000)]
  ];
  dim.runCommandAsync(`tp ${entity.name} ${tpCoords[random - 1][0]} 300 ${tpCoords[random - 1][1]}`);
  entity.runCommandAsync("gamerule sendcommandfeedback true");
  if (getGameMode(entity) != "creative") entity.addTag("randomTele");
}

function simpledifficulty(player) {
  const posX = Math.floor(player.location.x);
  const posY = Math.floor(player.location.y);
  const posZ = Math.floor(player.location.z);
  const dim = player.dimension;
  function block(x, y, z) {
    return dim.getBlock({ x: posX + x, y: posY + y, z: posZ + z });
  }
  function getNearBlock(blockName, type, x, z) {
    const positions = [
      [x, 0, z], [-x, 0, z], [x, 0, -z], [-x, 0, -z],
      [x, -1, z], [-x, -1, z], [x, -1, -z], [-x, -1, -z]
    ];
    positions.forEach(([dx, dy, dz]) => {
      const blk = block(dx, dy, dz);
      if (blk && blk.typeId && blk.typeId.includes(blockName)) {
        player.addTag(`isnear${type}`);
      }
    });
  }
  const currentBlock = block(0, 0, 0);
  if (currentBlock && currentBlock.typeId) {
    if (currentBlock.typeId.includes("water")) player.addTag("isonwater");
    if (currentBlock.typeId.includes("lava")) player.addTag("isonlava");
    if (currentBlock.typeId.includes("fire")) player.addTag("isonfire");
  }
  const blockTypes = [
    { name: "water", type: "water" },
    { name: "lava", type: "lava" },
    { name: "fire", type: "fire" },
    { name: "campfire", type: "fire" },
    { name: "soul_campfire", type: "fire" }
  ];
  blockTypes.forEach(({ name, type }) => {
    getNearBlock(name, type, 1, 0);
    getNearBlock(name, type, 1, 1);
  });
}

function teleportToSpawnPoint(entity) {
  entity.getTags().forEach(tag => {
    if (tag.includes("spawnPoint:")) {
      let l = tag.split(":"),
        posX = parseInt(l[l.length - 3]),
        posY = parseInt(l[l.length - 2]),
        posZ = parseInt(l[l.length - 1]),
        dim = l[l.length - 4];
      entity.runCommand("gamerule sendcommandfeedback false");
      world.getDimension(dim).runCommand(`tp ${entity.name} ${posX} ${posY} ${posZ}`);
      entity.runCommand("gamerule sendcommandfeedback true");
    }
  })
}

function showTeleportForm(player) {
  let form = new ActionFormData()
    .title("Teleport to Player")
    .body("Select a player to teleport to:");
  world.getAllPlayers().forEach(p => {
    form.button(p.name);
  });
  form.show(player).then(response => {
    if (response.selection !== undefined) {
      let targetPlayer = world.getAllPlayers()[response.selection];
      player.teleport(targetPlayer.location);
    }
  });
}

var nameDrawers = {
  "mhqstudios:storage_drawers.oak_drawer": {
    "name": "%oak_drawer.name"
  },
  "mhqstudios:storage_drawers.birch_drawer": {
    "name": "%birch_drawer.name"
  },
  "mhqstudios:storage_drawers.cherry_drawer": {
    "name": "%cherry_drawer.name"
  },
  "mhqstudios:storage_drawers.mangrove_drawer": {
    "name": "%mangrove_drawer.name"
  },
  "mhqstudios:storage_drawers.dark_oak_drawer": {
    "name": "%dark_oak_drawer.name"
  },
  "mhqstudios:storage_drawers.jungle_drawer": {
    "name": "%jungle_drawer.name"
  },
  "mhqstudios:storage_drawers.spruce_drawer": {
    "name": "%spruce_drawer.name"
  },
  "mhqstudios:storage_drawers.acacia_drawer": {
    "name": "%acacia_drawer.name"
  },
  "mhqstudios:storage_drawers.crimson_drawer": {
    "name": "%crimson_drawer.name"
  },
  "mhqstudios:storage_drawers.warped_drawer": {
    "name": "%warped_drawer.name"
  },
  "mhqstudios:storage_drawers.bamboo_drawer": {
    "name": "%bamboo_drawer.name"
  }
};

var ignoreBlock = [
  "minecraft:red_flower",
  "minecraft:hopper",
  "minecraft:cauldron",
  "minecraft:oak_hanging_sign",
  "minecraft:dark_oak_hanging_sign",
  "minecraft:spruce_hanging_sign",
  "minecraft:birch_hanging_sign",
  "minecraft:jungle_hanging_sign",
  "minecraft:acacia_hanging_sign",
  "minecraft:mangrove_hanging_sign",
  "minecraft:cherry_hanging_sign",
  "minecraft:bamboo_hanging_sign",
  "minecraft:crimson_hanging_sign",
  "minecraft:warped_hanging_sign",
  "minecraft:flower_pot",
  "minecraft:brewing_stand",
  "minecraft:frame",
  "minecraft:glow_frame",
  "minecraft:rail",
  "minecraft:golden_rail",
  "minecraft:detector_rail",
  "minecraft:activator_rail",
  "minecraft:campfire",
  "minecraft:soul_campfire",
  "minecraft:bell",
  "minecraft:chain",
  "minecraft:bed",
  "minecraft:tripwire_hook",
  "minecraft:torch",
  "minecraft:soul_torch",
  "minecraft:sea_pickle",
  "minecraft:lantern",
  "minecraft:soul_lantern",
  "minecraft:redstone_torch",
  "minecraft:lever",
  "minecraft:wooden_door",
  "minecraft:mangrove_door",
  "minecraft:spruce_door",
  "minecraft:birch_door",
  "minecraft:jungle_door",
  "minecraft:acacia_door",
  "minecraft:dark_oak_door",
  "minecraft:cherry_door",
  "minecraft:bamboo_door",
  "minecraft:iron_door",
  "minecraft:crimson_door",
  "minecraft:warped_door",
  "minecraft:sapling",
  "minecraft:mangrove_propagule",
  "minecraft:cherry_sapling",
  "minecraft:tallgrass",
  "minecraft:double_plant",
  "minecraft:nether_sprouts",
  "minecraft:pointed_dripstone",
  "minecraft:twisting_vines",
  "minecraft:weeping_vines",
  "minecraft:waterlily",
  "minecraft:deadbush",
  "minecraft:tallgrass",
  "minecraft:double_plant",
  "minecraft:nether_sprouts",
  "minecraft:seagrass",
  "minecraft:frog_spawn",
  "minecraft:web",
  "minecraft:candle",
  "minecraft:white_candle",
  "minecraft:orange_candle",
  "minecraft:magenta_candle",
  "minecraft:light_blue_candle",
  "minecraft:yellow_candle",
  "minecraft:lime_candle",
  "minecraft:pink_candle",
  "minecraft:gray_candle",
  "minecraft:light_gray_candle",
  "minecraft:cyan_candle",
  "minecraft:purple_candle",
  "minecraft:blue_candle",
  "minecraft:brown_candle",
  "minecraft:red_candle",
  "minecraft:green_candle",
  "minecraft:black_candle",
  "minecraft:fire_coral",
  "minecraft:brain_coral",
  "minecraft:bubble_coral",
  "minecraft:tube_coral",
  "minecraft:horn_coral",
  "minecraft:dead_fire_coral",
  "minecraft:dead_brain_coral",
  "minecraft:dead_bubble_coral",
  "minecraft:dead_tube_coral",
  "minecraft:dead_horn_coral",
  "minecraft:coral_fan",
  "minecraft:coral_fan_dead",
  "minecraft:torchflower",
  "minecraft:pink_petals",
  "minecraft:crimson_roots",
  "minecraft:warped_roots",
  "minecraft:yellow_flower",
  "minecraft:wither_rose",
  "minecraft:hanging_roots",
  "minecraft:vine",
  "minecraft:glow_lichen",
  "minecraft:turtle_egg",
  "minecraft:sniffer_egg",
  "minecraft:nether_wart",
  "minecraft:red_mushroom",
  "minecraft:brown_mushroom",
  "minecraft:crimson_fungus",
  "minecraft:warped_fungus",
  "minecraft:iron_bars",
  "minecraft:ladder",
  "minecraft:cake",
  "minecraft:kelp",
  "minecraft:copper_door",
  "minecraft:exposed_copper_door",
  "minecraft:oxidized_copper_door",
  "minecraft:waxed_copper_door",
  "minecraft:waxed_exposed_copper_door",
  "minecraft:waxed_oxidized_copper_door",
  "minecraft:waxed_weathered_copper_door",
  "minecraft:weathered_copper_door"
];

function calcDistance(loc1, loc2) {
  return Math.sqrt(
    Math.pow(loc2.x - loc1.x, 2) +
    Math.pow(loc2.y - loc1.y, 2) +
    Math.pow(loc2.z - loc1.z, 2)
  );
}

function getDistance(a, b) {
  const { x: x1, y: y1, z: z1 } = a.location;
  const { x: x2, y: y2, z: z2 } = b.location;
  return Math.hypot(x2 - x1, y2 - y1, z2 - z1);
}

function getTargetDistance(entityA, entityB) {
  const locationA = entityA.location;
  const locationB = entityB.location;
  const x1 = locationA.x, y1 = locationA.y, z1 = locationA.z;
  const x2 = locationB.x, y2 = locationB.y, z2 = locationB.z;
  const distance = Math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2 + (z2 - z1) ** 2);
  return Math.floor(distance);
}

function getScore(entity, objective) {
  try {
    const scoreObj = world.scoreboard.getObjective(objective);
    const scoreId = entity.scoreboardIdentity;
    return scoreObj.getScore(scoreId);
  } catch {
    return undefined;
  }
}

function spawnDirection(direction, x, y, z) {
  let newX = x, newY = y, newZ = z;
  switch (direction) {
    case "Up":
      newY = y + 1;
      break;
    case "Down":
      newY = y - 1;
      break;
    case "East":
      newX = x + 1;
      break;
    case "West":
      newX = x - 1;
      break;
    case "North":
      newZ = z - 1;
      break;
    case "South":
      newZ = z + 1;
      break;
    default:
      break;
  }
  return { x: newX, y: newY, z: newZ };
}

function spawnItemDirection(entity, item, amount, direction, location) {
  const { x, y, z } = location;
  return world.getDimension(entity.dimension.id).spawnItem(new ItemStack(item, amount), spawnDirection(direction, x, y, z));
}

function clearItemSlot(source, slot, item, amount) {
  let equipment = source.getComponent(EntityComponentTypes.Equippable);
  let gameMode = getGameMode(source);
  if (gameMode != "creative") {
    if (item.amount > 1) {
      equipment.setEquipment(slot, new ItemStack(item.typeId, item.amount - amount));
    } else {
      equipment.setEquipment(slot, null);
    }
  }
}

function resetItemInventory(source) {
  system.runTimeout(() => {
    let inventory = source.getComponent("inventory").container;
    if (inventory.size > 0) {
      for (let i = 0; i < inventory.size; i++) {
        let item = inventory.getItem(i);
        if (item) {
          inventory.setItem(i, null);
          inventory.setItem(i, item.clone());
        }
      }
    }
  }, 5);
}

const scoreboardList = [
  "bow",
  "crossbow",
  "bowusing",
  "bowpulltime",
  "crossbowusing",
  "crossbowpulltime",
  "arrowinv",
  "bowpulltimes",
  "bowpulltimemax",
  "crossbowpulltimes",
  "crossbowpulltimemax",
  "maxhead",
  "maxbody",
  "maxleftarm",
  "maxrightarm",
  "maxleftfoot",
  "maxrightfoot",
  "maxleftleg",
  "maxrightleg",
  "head",
  "body",
  "leftarm",
  "rightarm",
  "leftfoot",
  "rightfoot",
  "leftleg",
  "rightleg",
  "attacklevel",
  "mininglevel",
  "defenselevel",
  "agilitylevel",
  "magiclevel",
  "gatheringlevel",
  "buildinglevel",
  "farminglevel"
];

function addScoreObjectives(entity, objective) {
  return entity.runCommand(`scoreboard objectives add ${objective} dummy`);
}
function addScoreboard(entity, objective, number) {
  return entity.runCommand(`scoreboard players add @s ${objective} ${number} `);
}
function setScoreboard(entity, objective, number) {
  return entity.runCommand(`scoreboard players set @s ${objective} ${number} `);
}

function addXp(entity, level, condition) {
  if (condition === "level") {
    return entity.runCommandAsync(`xp ${level}l @s`);
  } else if (condition === "ex") {
    return entity.runCommandAsync(`xp ${level} @s`);
  }
}

function getColorByDamage(damage) {
  if (damage === 0) return "\xa7a";
  if (damage > 9.0 && damage <= 15.0) return "\xa76";
  if (damage > 15.0 && damage <= 19.0) return "\xa7c";
  if (damage > 19.0) return "\xa74";
  return "\xa7e";
}

world.afterEvents.entityHitEntity.subscribe(data => {
  const attacker = data.damagingEntity;
  const target = data.hitEntity;
  if (attacker.typeId === "minecraft:player") {
    const equippableComponent = attacker.getComponent(EntityComponentTypes.Equippable);
    if (equippableComponent) {
      const mainhandItem = equippableComponent.getEquipment(EquipmentSlot.Mainhand);
      if (mainhandItem) {
        if (mainhandItem.hasTag("minecraft:is_sword")) {
          world.playSound("sound_attack", attacker.location);
        } else if (
          mainhandItem.hasTag("minecraft:is_axe") ||
          mainhandItem.hasTag("minecraft:is_pickaxe") ||
          mainhandItem.hasTag("minecraft:is_shovel") ||
          mainhandItem.hasTag("minecraft:is_hoe")
        ) {
          world.playSound("tools_swing", attacker.location);
        }
      }
    }
  }
});

const skillableObject = {
  attack: "attack",
  mining: "mining",
  defense: "defense",
  gathering: "gathering",
  building: "building",
  farming: "farming",
  magic: "magic",
  agility: "agility",
  maxLevel: 32
}

function dropItem(entity, itemName, amount) {
  const itemStack = new ItemStack(itemName, amount);
  entity.dimension.spawnItem(itemStack, entity.location);
}

function checkArmorSet(player, set) {
  const eqmor = player.getComponent(EntityComponentTypes.Equippable);
  const { Head, Chest, Legs, Feet } = EquipmentSlot;
  return eqmor.getEquipment(Head)?.typeId === set.head &&
    eqmor.getEquipment(Chest)?.typeId === set.chest &&
    eqmor.getEquipment(Legs)?.typeId === set.legs &&
    eqmor.getEquipment(Feet)?.typeId === set.feet;
}

function applyEffect(player, effect, duration) {
  player.addEffect(effect, duration);
}

const armorSets = [
  {
    set: {
      head: "iceandfire:silver_helmet",
      chest: "iceandfire:silver_chestplate",
      legs: "iceandfire:silver_leggings",
      feet: "iceandfire:silver_boots"
    },
    effect: "speed"
  },
  {
    set: {
      head: "allainmc:neptunium_helmet",
      chest: "allainmc:neptunium_chestplate",
      legs: "allainmc:neptunium_leggings",
      feet: "allainmc:neptunium_boots"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:deepblue_tide_h",
      chest: "iceandfire:deepblue_tide_c",
      legs: "iceandfire:deepblue_tide_l",
      feet: "iceandfire:deepblue_tide_b"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:blue_tide_h",
      chest: "iceandfire:blue_tide_c",
      legs: "iceandfire:blue_tide_l",
      feet: "iceandfire:blue_tide_b"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:red_tide_h",
      chest: "iceandfire:red_tide_c",
      legs: "iceandfire:red_tide_l",
      feet: "iceandfire:red_tide_b"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:bronze_tide_h",
      chest: "iceandfire:bronze_tide_c",
      legs: "iceandfire:bronze_tide_l",
      feet: "iceandfire:bronze_tide_b"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:green_tide_h",
      chest: "iceandfire:green_tide_c",
      legs: "iceandfire:green_tide_l",
      feet: "iceandfire:green_tide_b"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:teal_tide_h",
      chest: "iceandfire:teal_tide_c",
      legs: "iceandfire:teal_tide_l",
      feet: "iceandfire:teal_tide_b"
    },
    effect: "water_breathing"
  },
  {
    set: {
      head: "iceandfire:purple_tide_h",
      chest: "iceandfire:purple_tide_c",
      legs: "iceandfire:purple_tide_l",
      feet: "iceandfire:purple_tide_b"
    },
    effect: "water_breathing"
  }
];

world.afterEvents.entityHurt.subscribe((data) => {
  const { hurtEntity, cause, damage } = data;
  if (hurtEntity.typeId !== "tanmc:dmgnumber" && damage >= 0) {
    const loc = hurtEntity.location;
    if (loc && loc.x !== undefined && loc.y !== undefined && loc.z !== undefined) {
      const dimension = hurtEntity.dimension;
      let dmgnumber = dimension.spawnEntity("tanmc:dmgnumber", {
        x: loc.x,
        y: loc.y + 1.8,
        z: loc.z
      });
      let color = getColorByDamage(damage);
      dmgnumber.nameTag = `${color}\xa7l${damage}`;
      system.runTimeout(() => {
        dmgnumber.triggerEvent("despawn");
      }, 20);
    }
  }
});

world.afterEvents.itemUseOn.subscribe((data) => {
  const { source, itemStack, block } = data;
  const { x: lx, y: ly, z: lz } = block.location;
  const dimension = source.dimension;
  if (block.typeId === "minecraft:bed" && getTargetDistance(source, block) <= 3) {
    source.getTags().forEach(tag => {
      if (tag.startsWith("spawnPoint:")) {
        source.removeTag(tag);
      }
    });
    system.runTimeout(() => {
      source.addTag(`spawnPoint:${dimension.id.split(":")[1]}:${lx}:${ly}:${lz}`);
    }, 1);
  }
});

world.afterEvents.itemCompleteUse.subscribe(data => {
  const { itemStack, source } = data;
  if (itemStack.typeId === "firstaid:morphine") {
    source.addTag("UsingMorphine");
    system.runTimeout(() => {
      source.removeTag("UsingMorphine");
    }, 3600);
  } else if (itemStack.typeId === "bountiful:potion_recall") {
    const gamemode = getGameMode(source);
    if (source.getTags().some(tag => tag.includes("spawnPoint:") && source.hasTag("setSpawnPoint"))) {
      teleportToSpawnPoint(source);
    }
  } else if (itemStack.typeId === "allainmc:battleburito") {
    source.runCommand('effect @s strength 25 1 true');
    source.runCommand('effect @s resistance 25 1 true');
  }
});

world.afterEvents.itemCompleteUse.subscribe((data) => {
  const { source, itemStack } = data;
  if (itemStack.typeId === "firstaid:heart_container") {
    system.runTimeout(() => {
      const defaultHealth = source.getComponent("minecraft:health").defaultValue;
      function randomAddHealth() {
        const random = Math.floor(Math.random() * 8);
        source.triggerEvent(`add_health.${defaultHealth + 1}`);
        const scores = [
          { part: "head", maxPart: "maxhead" },
          { part: "body", maxPart: "maxbody" },
          { part: "leftarm", maxPart: "maxleftarm" },
          { part: "rightarm", maxPart: "maxrightarm" },
          { part: "leftfoot", maxPart: "maxleftfoot" },
          { part: "rightfoot", maxPart: "maxrightfoot" },
          { part: "leftleg", maxPart: "maxleftleg" },
          { part: "rightleg", maxPart: "maxrightleg" }
        ];
        const { part, maxPart } = scores[random];
        const currentScore = getScore(source, part) || 0;
        const maxScore = getScore(source, maxPart) || 0;
        if (currentScore >= maxScore) {
          randomAddHealth();
        } else {
          addScoreboard(source, part, 1);
        }
      }
      randomAddHealth();
    }, 0);
  }
});

system.runInterval(() => {
  const players = world.getAllPlayers();
  players.forEach(player => {
    if (!player.hasTag("UsingMorphine")) {
      const scores = {
        leftarm: getScore(player, "leftarm"),
        rightarm: getScore(player, "rightarm"),
        leftfoot: getScore(player, "leftfoot"),
        rightfoot: getScore(player, "rightfoot"),
        leftleg: getScore(player, "leftleg"),
        rightleg: getScore(player, "rightleg")
      };
      if (scores.leftarm <= 0 || scores.rightarm <= 0) {
        player.addEffect("mining_fatigue", 20, { amplifier: 2, showParticles: false });
      }
      if (scores.leftfoot <= 0 || scores.rightfoot <= 0 || scores.leftleg <= 0 || scores.rightleg <= 0) {
        player.addEffect("slowness", 20, { amplifier: 1, showParticles: false });
      }
    }
  });
});

function SkillOpen(player) {
  const actionform = new ActionFormData();
  actionform.title('title.skill.id');
  actionform.button("skill.farming.id");
  actionform.button("skill.defense.id");
  actionform.button("skill.attack.id");
  actionform.button("skill.magic.id");
  actionform.button("skill.agility.id");
  actionform.button("skill.building.id");
  actionform.button("skill.gathering.id");
  actionform.button("skill.mining.id");
  actionform.show(player).then(result => {
    const skills = [
      { name: "farming", level: "farminglevel" },
      { name: "defense", level: "defenselevel" },
      { name: "attack", level: "attacklevel" },
      { name: "magic", level: "magiclevel" },
      { name: "agility", level: "agilitylevel" },
      { name: "building", level: "buildinglevel" },
      { name: "gathering", level: "gatheringlevel" },
      { name: "mining", level: "mininglevel" }
    ];
    const selectedSkill = skills[result.selection];
    if (selectedSkill) {
      const currentSkillLevel = getScore(player, selectedSkill.name);
      const requiredLevel = getScore(player, selectedSkill.level);
      const playerLevel = player.level;
      const gameMode = getGameMode(player); // Assuming this function returns true if the player is in creative mode
      if (currentSkillLevel < 32) {
        if (gameMode != "creative") {
          if (playerLevel >= requiredLevel) {
            addXp(player, -requiredLevel, "level");
            addScoreboard(player, selectedSkill.level, 1);
            addScoreboard(player, selectedSkill.name, 1);
            player.sendMessage(`Current ${selectedSkill.name} level is: ${currentSkillLevel + 1}`);
          } else {
            player.sendMessage(`You need ${requiredLevel} levels to skill up.`);
          }
        } else {
          addScoreboard(player, selectedSkill.level, 1);
          addScoreboard(player, selectedSkill.name, 1);
          player.sendMessage(`Current ${selectedSkill.name} level is: ${currentSkillLevel + 1}`);
        }
      }
    }
  });
}

world.afterEvents.itemUse.subscribe(data => {
  const player = data.source;
  const item = data.itemStack;
  if (item.typeId == 'reskillable:skill_book') {
    SkillOpen(player);
  }
});

system.runInterval(() => {
  for (let player of world.getPlayers()) {
    const { x, y, z } = player.location;
    let heart = player.getComponent("health");
    let equipmentInventory = player.getComponent(EntityComponentTypes.Equippable),
      itemSlotMainHand = equipmentInventory.getEquipment(EquipmentSlot.Mainhand),
      itemSlotOffHand = equipmentInventory.getEquipment(EquipmentSlot.Offhand),
      itemSlotChest = equipmentInventory.getEquipment(EquipmentSlot.Chest),
      itemSlotHead = equipmentInventory.getEquipment(EquipmentSlot.Head),
      itemSlotLegs = equipmentInventory.getEquipment(EquipmentSlot.Legs),
      itemSlotFeet = equipmentInventory.getEquipment(EquipmentSlot.Feet),
      Gamemode = getGameMode(player);
    if (player.hasTag("randomTele")) {
      let block = player.dimension.getBlock({ x: player.location.x, y: player.location.y - 3, z: player.location.z });
      if (block) { // the block is defined
        player.addEffect("resistance", 30, { amplifier: 255, showParticles: false });
        if (block.typeId !== "minecraft:air") {
          player.removeTag("randomTele");
        }
      }
    };
    if (heart.currentValue > 20) {
      if (!player.hasTag("healup")) {
        player.addTag("healup");
      }
    } else {
      if (player.hasTag("healup")) {
        player.removeTag("healup");
      }
    };
    const maxScores = player.hasTag("healup")
      ? { head: 10, body: 10, leftarm: 8, leftleg: 8, leftfoot: 8, rightarm: 8, rightleg: 8, rightfoot: 8 }
      : { head: 3, body: 5, leftarm: 2, leftleg: 2, leftfoot: 2, rightarm: 2, rightleg: 2, rightfoot: 2 };
    for (let part in maxScores) {
      if (getScore(player, part) >= maxScores[part]) {
        setScoreboard(player, part, maxScores[part]);
      }
    };
    if (!player.hasTag('Scoreboard:load')) {
      scoreboardList.forEach(scorelist => {
        addScoreObjectives(player, scorelist);
        addScoreboard(player, scorelist, 0);
      });
      const defaultScores = {
        "bowpulltimes": 18, "crossbowpulltimes": 21,
        "bowpulltimemax": 3, "crossbowpulltimemax": 3,
        "head": 3, "body": 5, "leftarm": 2, "rightarm": 2,
        "leftleg": 2, "rightleg": 2, "leftfoot": 2, "rightfoot": 2,
        "maxhead": 10, "maxbody": 10, "maxleftarm": 8, "maxrightarm": 8,
        "maxleftleg": 8, "maxrightleg": 8, "maxleftfoot": 8, "maxrightfoot": 8,
        "health_max": 0, "attacklevel": 2, "defenselevel": 2, "farminglevel": 2,
        "agilitylevel": 2, "buildinglevel": 2, "gatheringlevel": 2, "mininglevel": 2,
        "magiclevel": 2, "attack": 0, "defense": 0, "farming": 0, "agility": 0,
        "building": 0, "gathering": 0, "mining": 0
      };
      for (let score in defaultScores) {
        setScoreboard(player, score, defaultScores[score]);
      }
      player.runCommand("gamerule commandblockoutput false");
      player.runCommand("gamerule showdeathmessages false");
      player.runCommand("gamerule naturalregeneration false");
      player.addTag('Scoreboard:load');
      player.addTag("rlcraft.load");
    }
    if (Gamemode != "creative") {
      if (!player.hasTag("isPlAlive")) {
        player.addTag("playerHasDeath");
      }
      if (player.hasTag("playerHasDeath")) {
        if (!player.hasTag("setSpawnPoint")) {
          randomSpawn(player);
          player.removeTag("playerHasDeath");
        }
      }
    }
    player.getTags().forEach(tag => {
      if (tag.includes("spawnPoint:")) {
        if (!player.hasTag("setSpawnPoint"))
          player.addTag("setSpawnPoint");
        let l = tag.split(":");
        if (player.dimension.id.split(":")[1] == `${l[l.length - 4]}`) {
          if (targetActiveInChunk(player.location, { x: l[l.length - 3], y: l[l.length - 2], z: l[l.length - 1] }) <= 100) {
            if (player.dimension.getBlock({ x: parseInt(l[l.length - 3]), y: parseInt(l[l.length - 2]), z: parseInt(l[l.length - 1]) }).typeId != "minecraft:bed") {
              player.removeTag("setSpawnPoint");
              player.removeTag(`spawnPoint:${l[l.length - 4]}:${parseInt(l[l.length - 3])}:${parseInt(l[l.length - 2])}:${parseInt(l[l.length - 1])}`);
            }
          }
        }
      }
    })
    if (Gamemode != "creative") {
      player.runCommand(`scoreboard players set @s[hasitem={item=minecraft:arrow,quantity=1..},scores={arrowinv=0}] arrowinv 1`);
      player.runCommand(`scoreboard players set @s[hasitem={item=minecraft:arrow,quantity=..0},scores={arrowinv=1}] arrowinv 0`);
    }
    else {
      if (getScore(player, "arrowinv") == 0) {
        setScoreboard(player, "arrowinv", 1);
      }
    };
    if (player.hasTag("rlcraft.load")) {
      simpledifficulty(player);
      armorSets.forEach(({ set, effect }) => {
        if (checkArmorSet(player, set)) {
          applyEffect(player, effect, 180);
        }
      })
    };
    player.getTags().forEach(tag => {
      if (tag.includes("firstaid:damage_")) {
        if (player.hasTag("rlcraft.load")) {
          player.triggerEvent(`firstaid:damage`);
        }
      }
    });
    if (player.hasTag("rlcraft.load")) {
      let equip = player.getComponent(EntityComponentTypes.Equippable),
        atk = getScore(player, skillableObject.attack),
        min = getScore(player, skillableObject.mining),
        def = getScore(player, skillableObject.defense),
        agi = getScore(player, skillableObject.agility),
        mag = getScore(player, skillableObject.magic),
        bui = getScore(player, skillableObject.building),
        far = getScore(player, skillableObject.farming),
        gat = getScore(player, skillableObject.gathering);
      let effectskill = (ae) => {
        if (ae == 0) {
          player.addEffect("weakness", 3, {
            amplifier: 255, showParticles: false
          });
          player.addEffect("mining_fatigue", 3, {
            amplifier: 255, showParticles: false
          });
        };
        if (ae == 1) {
          player.addEffect("weakness", 3, {
            amplifier: 255, showParticles: false
          });
          player.addEffect("mining_fatigue", 3, {
            amplifier: 255, showParticles: false
          });
          player.addEffect("slowness", 4, {
            amplifier: 255, showParticles: false
          });
        }
      };
      if (!world.getPlayers({ gameMode: "creative" }).some(players => players.name === player.name)) {
        for (let st of [EquipmentSlot.Mainhand, EquipmentSlot.Offhand]) {
          let eq = equip.getEquipment(st);
          if (eq != undefined) {
            let t = (a) => {
              if (eq.typeId == a || eq.hasTag(a)) return a;
            };
            if (
              (t("minecraft:iron_sword") && !(atk >= 8)) ||
              (t("minecraft:golden_sword") && !(atk >= 2 && mag >= 4)) ||
              (t("minecraft:diamond_sword") && !(atk >= 16)) ||
              (t("minecraft:netherite_sword") && !(atk >= 20)) ||
              (t("minecraft:iron_pickaxe") && !(min >= 8)) ||
              (t("minecraft:golden_pickaxe") && !(min >= 2 && mag >= 4)) ||
              (t("minecraft:diamond_pickaxe") && !(min >= 16)) ||
              (t("minecraft:netherite_pickaxe") && !(min >= 20)) ||
              (t("minecraft:iron_axe") && !(gat >= 8)) ||
              (t("minecraft:golden_axe") && !(gat >= 8 && mag >= 4)) ||
              (t("minecraft:diamond_axe") && !(gat >= 16)) ||
              (t("minecraft:netherite_axe") && !(gat >= 20)) ||
              (t("minecraft:iron_shovel") && !(gat >= 8)) ||
              (t("minecraft:golden_shovel") && !(gat >= 8 && mag >= 4)) ||
              (t("minecraft:diamond_shovel") && !(gat >= 16)) ||
              (t("minecraft:netherite_shovel") && !(gat >= 20)) ||
              (t("minecraft:iron_hoe") && !(far >= 8)) ||
              (t("minecraft:golden_hoe") && !(far >= 2 && mag >= 4)) ||
              (t("minecraft:diamond_hoe") && !(far >= 16)) ||
              (t("minecraft:netherite_hoe") && !(far >= 20)) ||
              (t("attacklevel:2") && !(atk >= 2)) ||
              (t("attacklevel:4") && !(atk >= 4)) ||
              (t("attacklevel:6") && !(atk >= 6)) ||
              (t("attacklevel:8") && !(atk >= 8)) ||
              (t("attacklevel:10") && !(atk >= 10)) ||
              (t("attacklevel:12") && !(atk >= 12)) ||
              (t("attacklevel:16") && !(atk >= 16)) ||
              (t("attacklevel:20") && !(atk >= 20)) ||
              (t("attacklevel:24") && !(atk >= 24)) ||
              (t("attacklevel:30") && !(atk >= 30)) ||
              (t("mininglevel:2") && !(min >= 2 && mag >= 4)) ||
              (t("mininglevel:4") && !(min >= 4)) ||
              (t("mininglevel:6") && !(min >= 6)) ||
              (t("mininglevel:8") && !(min >= 8)) ||
              (t("mininglevel:10") && !(min >= 10)) ||
              (t("mininglevel:12") && !(min >= 12)) ||
              (t("mininglevel:16") && !(min >= 16)) ||
              (t("mininglevel:20") && !(min >= 20)) ||
              (t("mininglevel:24") && !(min >= 24)) ||
              (t("mininglevel:30") && !(min >= 30)) ||
              (t("gatheringlevel:2") && !(gat >= 2 && mag >= 4)) ||
              (t("gatheringlevel:4") && !(gat >= 4)) ||
              (t("gatheringlevel:6") && !(gat >= 6)) ||
              (t("gatheringlevel:8") && !(gat >= 8)) ||
              (t("gatheringlevel:10") && !(gat >= 10)) ||
              (t("gatheringlevel:12") && !(gat >= 12)) ||
              (t("gatheringlevel:16") && !(gat >= 16)) ||
              (t("gatheringlevel:20") && !(gat >= 20)) ||
              (t("gatheringlevel:24") && !(gat >= 24)) ||
              (t("gatheringlevel:30") && !(gat >= 30)) ||
              (t("farminglevel:2") && !(far >= 2 && mag >= 4)) ||
              (t("farminglevel:4") && !(far >= 4)) ||
              (t("farminglevel:6") && !(far >= 6)) ||
              (t("farminglevel:8") && !(far >= 8)) ||
              (t("farminglevel:10") && !(far >= 10)) ||
              (t("farminglevel:12") && !(far >= 12)) ||
              (t("farminglevel:16") && !(far >= 16)) ||
              (t("farminglevel:20") && !(far >= 20)) ||
              (t("farminglevel:24") && !(far >= 24)) ||
              (t("farminglevel:30") && !(far >= 30))
            ) {
              effectskill(0);
            };
            if (
              (t("minecraft:shield") && !(def >= 12)) ||
              (t("defenselevel:2") && !(def >= 2 && mag >= 4)) ||
              (t("defenselevel:16") && !(def >= 16)) ||
              (t("defenselevel:8") && !(def >= 8)) ||
              (t("defenselevel:20") && !(def >= 20))
            ) {
              effectskill(1)
            }
          }
        };
        for (let st of [EquipmentSlot.Chest, EquipmentSlot.Head, EquipmentSlot.Legs, EquipmentSlot.Feet]) {
          let eq = equip.getEquipment(st);
          const { x, y, z } = player.location;
          if (eq != undefined) {
            let t = (a) => {
              if (eq.typeId == a || eq.hasTag(a)) return a;
            };
            if (
              (t("minecraft:golden_chestplate") && !(def >= 2 && mag >= 4)) ||
              (t("minecraft:iron_chestplate") && !(def >= 8)) ||
              (t("minecraft:diamond_chestplate") && !(def >= 16)) ||
              (t("minecraft:netherite_chestplate") && !(def >= 20)) ||
              (t("minecraft:golden_helmet") && !(def >= 2 && mag >= 4)) ||
              (t("minecraft:iron_helmet") && !(def >= 8)) ||
              (t("minecraft:diamond_helmet") && !(def >= 16)) ||
              (t("minecraft:netherite_helmet") && !(def >= 20)) ||
              (t("minecraft:golden_leggings") && !(def >= 2 && mag >= 4)) ||
              (t("minecraft:iron_leggings") && !(def >= 8)) ||
              (t("minecraft:diamond_leggings") && !(def >= 16)) ||
              (t("minecraft:netherite_leggings") && !(def >= 20)) ||
              (t("minecraft:golden_boots") && !(def >= 2 && mag >= 4)) ||
              (t("minecraft:iron_boots") && !(def >= 8)) ||
              (t("minecraft:diamond_boots") && !(def >= 16)) ||
              (t("minecraft:netherite_boots") && !(def >= 20)) ||
              (t("minecraft:elytra") && !(agi >= 32)) ||
              (t("iceandfire:silver_helmet") && !(def >= 4 && mag >= 2)) ||
              (t("iceandfire:silver_chestplate") && !(def >= 4 && mag >= 2)) ||
              (t("iceandfire:silver_leggings") && !(def >= 4 && mag >= 2)) ||
              (t("iceandfire:silver_boots") && !(def >= 4 && mag >= 2)) ||
              (t("minecraft:chainmail_helmet") && !(def >= 4)) ||
              (t("minecraft:chainmail_chestplate") && !(def >= 4)) ||
              (t("minecraft:chainmail_leggings") && !(def >= 4)) ||
              (t("minecraft:chainmail_boots") && !(def >= 4)) ||
              (t("defenselevel:2") && !(def >= 2 && mag >= 4)) ||
              (t("defenselevel:4") && !(def >= 4)) ||
              (t("defenselevel:6") && !(def >= 6)) ||
              (t("defenselevel:8") && !(def >= 8)) ||
              (t("defenselevel:10") && !(def >= 10)) ||
              (t("defenselevel:12") && !(def >= 12)) ||
              (t("defenselevel:16") && !(def >= 16)) ||
              (t("defenselevel:20") && !(def >= 20)) ||
              (t("defenselevel:24") && !(def >= 24)) ||
              (t("defenselevel:30") && !(def >= 30)) ||
              (t("defenselevel:32") && !(def >= 32))
            ) {
              player.dimension.spawnItem(eq.clone(), { x, y, z });
              equip.setEquipment(st, undefined);
              resetItemInventory(player);
            }
          }
        }
      };
    }
  }
});

world.afterEvents.itemUseOn.subscribe(async data => {
  const { block, source: player } = data;
  const { x, y, z } = block.location;
  const item = data.itemStack;
  if (getScore(player, 'farming') <= 8 && ['minecraft:wheat_seeds', 'minecraft:pumpkin_seeds', 'minecraft:melon_seeds', 'minecraft:potato', 'minecraft:beetroot_seeds', 'minecraft:carrot'].includes(item.typeId)) {
    if (block.typeId == 'minecraft:farmland') {
      player.runCommandAsync(`setblock ${x} ${y} ${z} dirt`);
    }
  }
});

system.runInterval(() => {
  for (let player of world.getPlayers()) {
    let equipmentInventory = player.getComponent('minecraft:equippable'),
      inventoryContainer = player.getComponent('minecraft:inventory').container,
      itemSlotMainHand = equipmentInventory.getEquipment(EquipmentSlot.Mainhand),
      gameMode = getGameMode(player);
    player.dimension.getEntities({ excludeFamilies: ['TanCoLe'] }).forEach(entities => {
      const { x, y, z } = entities.location;
      if (getTargetDistance(player, entities) <= 100 && entities.typeId.includes('tanmc') && entities.typeId.includes('arrow') && getTargetDistance(player, entities) == 1 && entities.isOnGround) {
        if (gameMode != 'creative') {
          player.dimension.spawnItem(new ItemStack('minecraft:arrow', 1), { x, y, z });
          resetItemInventory(player);
        }
        entities.kill();
      }
    });
    if (itemSlotMainHand) {
      const updateScore = (type, tags) => {
        Object.entries(tags).forEach(([tag, [attack, agility]]) => {
          if (itemSlotMainHand.hasTag(`${type}_type:${tag}`) &&
            (gameMode == 'creative' || (getScore(player, 'attack') >= attack && getScore(player, 'agility') >= agility))) {
            if (getScore(player, `${type}pulltime`) < getScore(player, `${type}pulltimes`)) {
              addScoreboard(player, `${type}pulltime`, 1);
            }
            if ((getScore(player, `${type}pulltime`) % (getScore(player, `${type}pulltimes`) / getScore(player, `${type}pulltimemax`))) == 0 && getScore(player, type) < getScore(player, `${type}pulltimemax`)) {
              addScoreboard(player, type, 1);
              if (type === 'crossbow') {
                player.runCommand('playsound crossbow.loading.middle @a[r=10] ~~~ 4 1 4');
              }
            }
          }
        });
      };
      const bowTags = {
        wood: [2, 3],
        leather: [4, 3],
        iron: [8, 6],
        gold: [3, 5],
        netherite: [20, 18],
        dragon: [24, 18],
        umbrium: [4, 3],
        fire_dragon: [24, 18],
        ice_dragon: [24, 18],
        diamond: [16, 12]
      };
      const crossbowTags = {
        wood: [2, 3],
        iron: [8, 4],
        leather: [4, 3],
        gold: [2, 4],
        netherite: [20, 12],
        dragon: [24, 12],
        umbrium: [4, 2],
        fire_dragon: [24, 12],
        ice_dragon: [24, 12],
        diamond: [16, 8]
      };
      // Handling bows
      if (itemSlotMainHand.hasTag('tanmc:is_bow')) {
        player.triggerEvent(`bow.animation:${getScore(player, 'bow')}`);
        if (getScore(player, 'bowusing') == 1 && getScore(player, 'arrowinv') == 1) {
          updateScore('bow', bowTags);
        }
        if (getScore(player, 'bowusing') == 0 && getScore(player, 'bow') < getScore(player, 'bowpulltimemax')) {
          if (getScore(player, 'bow') > 0) {
            setScoreboard(player, 'bow', 0);
            if (getScore(player, 'bowpulltime') > 0) {
              setScoreboard(player, 'bowpulltime', 0);
            }
          }
        }
      }
      // Handling crossbows
      if (itemSlotMainHand.hasTag('tanmc:is_crossbow')) {
        player.triggerEvent(`crossbow.animation:${getScore(player, 'crossbow')}`);
        if (getScore(player, 'crossbowusing') == 1 && getScore(player, 'arrowinv') == 1) {
          updateScore('crossbow', crossbowTags);
        }
        if ((getScore(player, 'crossbowusing') == 0 || getScore(player, 'crossbowusing') == 1) && getScore(player, 'crossbowpulltime') == getScore(player, 'crossbowpulltimes') && getScore(player, 'crossbow') == getScore(player, 'crossbowpulltimemax')) {
          let enchantments = itemSlotMainHand.getComponent('minecraft:enchantments');
          let hasInfinity = enchantments?.enchantments.some(e => e.type.id === 'minecraft:infinity') || false;
          if (gameMode != 'creative' && !hasInfinity) {
            player.runCommandAsync('clear @s arrow -1 1');
          }
          if (getScore(player, 'crossbowpulltime') > 0) {
            setScoreboard(player, 'crossbowpulltime', 0);
          }
        }
        if (getScore(player, 'crossbowusing') == 0 && getScore(player, 'crossbow') < getScore(player, 'crossbowpulltimemax')) {
          if (getScore(player, 'crossbow') > 0) {
            setScoreboard(player, 'crossbow', 0);
          }
          if (getScore(player, 'crossbowpulltime') > 0) {
            setScoreboard(player, 'crossbowpulltime', 0);
          }
        }
      }
      const effects = {
        'bountiful:ring_speed': [['speed', 5]],
        'bountiful:ring_night_vision': [['night_vision', 240]],
        'bountiful:ring_slow_falling': [['slow_falling', 5]],
        'bountiful:ring_strength': [['strength', 5]],
        'bountiful:ring_fire_resistance': [['fire_resistance', 5]],
        'bountiful:ring_regeneration': [['regeneration', 60, { showParticles: true }]],
        'bountiful:dragon_eye': [['resistance', 5], ['fire_resistance', 5], ['night_vision', 240]],
        'bountiful:obsidian_skull': [['resistance', 5]],
        'bountiful:vitamins': [['water_breathing', 5]]
      };
      const specialEffects = {
        'bountiful:wither_ring': player => player.runCommandAsync(`effect @e[family=monster,family=!wither,r=3] wither 1 3`),
        'bountiful:ankh_charm': player => {
          player.runCommandAsync('effect @s poison 1 255');
          player.runCommandAsync('effect @s wither 1 255');
          player.runCommandAsync('effect @s nausea 1 255');
        },
        'bountiful:bezoar': player => {
          let block = player.dimension.getBlock({ x: player.location.x, y: player.location.y - 1, z: player.location.z });
          if (block.typeId === 'minecraft:stone' || block.typeId === 'minecraft:planks') {
            player.addEffect('levitation', 5, { amplifier: 2, showParticles: false });
          }
        }
      };
      for (let player of world.getPlayers()) {
        let inventory = player.getComponent('minecraft:inventory').container;
        [9, 12].forEach(start => {
          for (let i = start; i < start + 3; i++) {
            let item = inventory.getItem(i);
            if (!item) continue;
            let effect = effects[item.typeId];
            if (effect) {
              effect.forEach(([type, duration, options = { amplifier: 2, showParticles: false }]) =>
                player.addEffect(type, duration, options)
              );
            } else if (specialEffects[item.typeId]) {
              specialEffects[item.typeId](player);
            }
          }
        });
      }
    }
  }
});

world.afterEvents.itemUse.subscribe((data) => {
  const { source, itemStack } = data;
  let GameMode = getGameMode(source);
  let equipmentInventory = source.getComponent(EntityComponentTypes.Equippable);
  let durability = itemStack.getComponent("durability");
  let enchantments = itemStack.getComponent("minecraft:enchantments");
  let hasInfinity = enchantments ? enchantments.enchantments.some(e => e.type.id === "minecraft:infinity") : false;
  if (itemStack.hasTag("tanmc:is_crossbow")) {
    if (getScore(source, "crossbow") == 3) {
      const crossbowTypes = {
        "diamond": "arrow_type:diamond",
        "wood": "arrow_type:wood",
        "iron": "arrow_type:iron",
        "umbrium": "arrow_type:iron",
        "leather": "arrow_type:wood",
        "gold": "arrow_type:gold",
        "netherite": "arrow_type:netherite",
        "dragon": "arrow_type:diamond",
        "ice_dragon": "arrow_type:dragon_ice",
        "fire_dragon": "arrow_type:dragon_fire"
      };
      for (let type in crossbowTypes) {
        if (itemStack.typeId.includes(type)) {
          source.triggerEvent(crossbowTypes[type]);
          break;
        }
      }
      source.runCommandAsync(`playsound crossbow.shoot @a[r=25] ~~~ 4 1 4`);
      source.runCommandAsync(`tag @s add durability.config`);
      source.runCommandAsync("scoreboard players set @s crossbow 0");
      source.runCommandAsync("scoreboard players set @s crossbowusing 0");
    }
  }
});

world.afterEvents.itemStopUse.subscribe((data) => {
  const { source, itemStack } = data;
  let GameMode = getGameMode(source);
  let equipmentInventory = source.getComponent(EntityComponentTypes.Equippable);
  let durability = itemStack.getComponent("durability");
  let enchantments = itemStack.getComponent("minecraft:enchantments");
  let hasInfinity = enchantments ? enchantments.enchantments.some(e => e.type.id === "minecraft:infinity") : false;
  if (itemStack.hasTag("tanmc:is_bow")) {
    if (getScore(source, "bow") >= 3) {
      const bowTypes = {
        "bow_type:diamond": "arrow_type:diamond",
        "bow_type:wood": "arrow_type:wood",
        "bow_type:iron": "arrow_type:iron",
        "bow_type:leather": "arrow_type:wood",
        "bow_type:umbrium": "arrow_type:iron",
        "bow_type:gold": "arrow_type:gold",
        "bow_type:netherite": "arrow_type:netherite",
        "bow_type:dragon": "arrow_type:diamond",
        "bow_type:ice_dragon": "arrow_type:dragon_ice",
        "bow_type:fire_dragon": "arrow_type:dragon_fire"
      };
      for (let tag in bowTypes) {
        if (itemStack.hasTag(tag)) {
          source.triggerEvent(bowTypes[tag]);
          break;
        }
      }
      source.runCommandAsync(`playsound random.bow @a[r=25] ~~~ 4 1 4`);
      source.runCommandAsync(`tag @s add durability.config`);
      source.runCommandAsync("scoreboard players set @s bow 0");
      source.runCommandAsync("scoreboard players set @s bowusing 0");
      if (GameMode != "creative" && !hasInfinity) {
        source.runCommandAsync("clear @s arrow -1 1");
      }
    }
  }
});

function cc(slot, item, player) {
  try {
    let durability = item.getComponent("durability");
    if (durability) {
      if (durability.damage + 1 < durability.maxDurability) {
        durability.damage += 1;
      } else {
        player.playSound("random.break", player.location);
        slot.setItem(undefined);
      }
      slot.setItem(item);
    } else {
      console.error('Durability component not found on item:', item);
    }
  } catch (e) {
    console.error('Error in cc function:', e);
  }
  return true;
}

const itemList = /spartanshield:(iron|wooden|stone|diamond|netherite|obsidian|golden|basic_copper|basic_silver)_shield/;

system.runInterval(() => {
  try {
    for (const player of world.getPlayers()) {
      if (player.hasTag('durability.config')) {
        try {
          const inventory = player.getComponent('minecraft:inventory').container;
          const selectedSlot = player.selectedSlot;
          if (typeof selectedSlot === 'number') {
            const item = inventory.getItem(selectedSlot);
            if (item) {
              cc(inventory.getSlot(selectedSlot), item, player);
            }
          }
          player.removeTag('durability.config');
        } catch (e) {
          console.error('Error processing player durability config:', e);
        }
      }
    }
    for (const player of world.getPlayers({ tags: ['shield.durability.damage'] })) {
      try {
        const equipment = player.getComponent('minecraft:equippable');
        const slots = [EquipmentSlot.Mainhand, EquipmentSlot.Offhand];
        for (const slot of slots) {
          const equippedItem = equipment.getEquipment(slot)?.item;
          if (equippedItem && itemList.test(equippedItem.typeId)) {
            cc(equipment.getSlot(slot), equippedItem, player);
          }
        }
        player.removeTag('shield.durability.damage');
      } catch (e) {
        console.error('Error processing shield durability damage:', e);
      }
    }
  } catch (e) {
    console.error('Error in system runInterval loop:', e);
  }
}, 1);

world.afterEvents.itemUseOn.subscribe(data => {
  const { itemStack: item, source: player, block } = data;
  const equipmentInv = player.getComponent(EntityComponentTypes.Equippable);
  const itemHand = equipmentInv.getEquipment(EquipmentSlot.Mainhand);
  const { x, y, z } = block.location;
  const Gamemode = getGameMode(player);
  if (Gamemode !== "creative" && itemHand && itemHand.hasTag("minecraft:is_axe")) {
    const blockTypeId = block.typeId;
    const logToPlanks = {
      "minecraft:oak_log": "oak_planks",
      "minecraft:stripped_oak_log": "oak_planks",
      "minecraft:birch_log": "birch_planks",
      "minecraft:stripped_birch_log": "birch_planks",
      "minecraft:dark_oak_log": "dark_oak_planks",
      "minecraft:stripped_dark_oak_log": "dark_oak_planks",
      "minecraft:jungle_log": "jungle_planks",
      "minecraft:stripped_jungle_log": "jungle_planks",
      "minecraft:spruce_log": "spruce_planks",
      "minecraft:stripped_spruce_log": "spruce_planks",
      "minecraft:acacia_log": "acacia_planks",
      "minecraft:stripped_acacia_log": "acacia_planks",
      "minecraft:cherry_log": "cherry_planks",
      "minecraft:stripped_cherry_log": "cherry_planks"
    };
    if (player.isSneaking && blockTypeId.includes("_planks")) {
      player.runCommandAsync(`setblock ${x} ${y} ${z} air`);
      player.runCommandAsync(`loot spawn ${x} ${y} ${z} loot stick`);
      player.runCommandAsync(`playsound dig.wood @a[r=10] ~~~ 4 1 4`);
    } else if (!player.isSneaking) {
      const plankType = logToPlanks[blockTypeId];
      if (plankType) {
        player.runCommandAsync(`setblock ${x} ${y} ${z} air`);
        player.runCommandAsync(`loot spawn ${x} ${y} ${z} loot ${plankType}`);
        player.runCommandAsync(`playsound dig.wood @a[r=10] ~~~ 4 1 4`);
      }
    }
  }
});

const cooldowns = {
  head: 0,
  body: 0,
  rightarm: 0,
  leftarm: 0,
  rightfoot: 0,
  leftfoot: 0,
  rightleg: 0,
  leftleg: 0
};

const COOLDOWN_TIME = 48 * 1000; // (48 seconds)

async function useFirstAidItem(player, itemType) {
  const panel = new ActionFormData()
    .title("First Aid")
    .body("Select the body part to use the first aid item on:");
  const bodyParts = ["head", "body", "rightarm", "leftarm", "rightfoot", "leftfoot", "rightleg", "leftleg"];
  for (const part of bodyParts) {
    const isCooldown = Date.now() < cooldowns[part];
    const buttonText = isCooldown ? `${part} (Cooldown)` : part;
    panel.button(buttonText, isCooldown ? "textures/ui/lock" : null);
  }
  const response = await panel.show(player);
  if (response.selection !== undefined) {
    const selectedPart = bodyParts[response.selection];
    if (Date.now() >= cooldowns[selectedPart]) {
      player.runCommandAsync(`function firstaidfunctions/${itemType}/${selectedPart}`);
      cooldowns[selectedPart] = Date.now() + COOLDOWN_TIME;
    } else {
      player.sendMessage("This body part is still in cooldown.");
    }
  }
}

world.afterEvents.itemUse.subscribe(v => {
  const player = v.source;
  const item = v.itemStack;
  if (item.typeId === "firstaid:bandage") {
    useFirstAidItem(player, "bandage");
  } else if (item.typeId === "firstaid:plaster") {
    useFirstAidItem(player, "plaster");
  }
});

world.afterEvents.playerBreakBlock.subscribe(data => {
  const { player, brokenBlockPermutation, block, dimension } = data;
  const { x, y, z } = block.location;
  const equipmentInventory = player.getComponent(EntityComponentTypes.Equippable);
  const itemStack = equipmentInventory.getEquipment(EquipmentSlot.Mainhand);
  const brokenBlockId = brokenBlockPermutation.type.id;
  const gameMode = getGameMode(player);
  if (gameMode === "creative") return;
  if (brokenBlockId.includes("wheat") && block.getBlockState().getValue("age") == 7) {
    player.runCommandAsync(`summon minecraft:xp_orb ${x} ${y} ${z}`);
    if (getScore(player, "farming") >= 12) {
      if (Math.random() >= 0.4) { // 40% chance
        dimension.spawnItem(new ItemStack("minecraft:wheat"), { x, y, z });
        resetItemInventory(player);
      }
    }
  }
  if (brokenBlockId.includes("tallgrass")) {
    if (itemStack && itemStack.typeId === "nopunchtree:flint_knife") {
      let random = Math.random() * 100;
      if (random >= 40 && random < 90) {
        dimension.spawnItem(new ItemStack("nopunchtree:plant_fiber"), { x, y, z });
      } else if (random >= 90) {
        dimension.spawnItem(new ItemStack("nopunchtree:plant_fiber", 2), { x, y, z });
      }
      if (random >= 97) {
        dimension.spawnEntity("allainmc:sprigan", { x, y, z });
      }
    }
  }
  if (itemStack && itemStack.hasTag("minecraft:is_pickaxe")) {
    switch (brokenBlockId) {
      case "minecraft:mob_spawner":
        player.runCommandAsync(`loot spawn ${x} ${y} ${z} loot "blocks/loot"`);
        break;
      case "test_ore":
        dimension.spawnItem(new ItemStack("test", 1), { x, y, z });
        break;
      default:
        if (["coal_ore", "iron_ore", "gold_ore", "diamond_ore"].some(id => brokenBlockId.includes(id))) {
          let random = Math.random() * 100;
          if (random >= 95) {
            let randomSpawn = Math.random() * 101;
            if (randomSpawn < 81) {
              dimension.spawnEntity("allainmc:geonach", { x, y, z });
            } else if (randomSpawn >= 96) {
              dimension.spawnEntity("allainmc:vapula", { x, y, z });
            }
          }
        }
    }
  }
  if (itemStack && itemStack.hasTag("minecraft:is_pickaxe")) {
    const cobblestoneVariants = [
      "minecraft:cobblestone", "minecraft:mossy_cobblestone", "minecraft:stone",
      "minecraft:sandstone", "minecraft:red_sandstone", "minecraft:andesite",
      "minecraft:granite", "minecraft:diorite"
    ];
    if (cobblestoneVariants.includes(brokenBlockId)) {
      dimension.getEntities({ type: "minecraft:item" }).forEach(item => {
        const itemS = item.getComponent("item").itemStack;
        const rockMappings = {
          "minecraft:cobblestone": "nopunchtree:stone_rock",
          "minecraft:red_sandstone": "nopunchtree:redsandstone_rock",
          "minecraft:sandstone": "nopunchtree:sandstone_rock",
          "minecraft:andesite": "nopunchtree:andesite_rock",
          "minecraft:granite": "nopunchtree:granite_rock",
          "minecraft:diorite": "nopunchtree:diorite_rock"
        };
        if (rockMappings[itemS.typeId]) {
          dimension.spawnItem(new ItemStack(rockMappings[itemS.typeId], 4), { x, y, z });
          item.kill();
        }
      });
      resetItemInventory(player);
    }
  }
});

world.beforeEvents.itemUseOn.subscribe((data) => {
  const { source, itemStack, block, blockFace } = data;
  const { x, y, z } = block.location;
  const dimension = source.dimension;
  system.runTimeout(() => {
    if (itemStack.typeId === "minecraft:flint") {
      if (block.hasTag("stone") || block.typeId.includes("deepslate") || block.typeId.includes("ore") || block.hasTag("stone")) {
        spawnItemDirection(source, `nopunchtree:flint_shard`, 2, blockFace, block.location);
        source.runCommandAsync(`clear @s minecraft:flint 0 1`);
        resetItemInventory(source);
      }
    }
  }, 0);
});

system.runInterval(() => {
  for (let player of world.getPlayers()) {
    let equipmentInventory = player.getComponent(EntityComponentTypes.Equippable);
    let itemSlotMainHand = equipmentInventory.getEquipment(EquipmentSlot.Mainhand);
    if (itemSlotMainHand && itemSlotMainHand.typeId.includes("xp_book")) {
      let durability = itemSlotMainHand.getComponent("durability");
      if (itemSlotMainHand.getLore().length === 0) {
        durability.damage += durability.maxDurability;
        itemSlotMainHand.setLore(["\xa7bxp: " + (durability.maxDurability - durability.damage) + "/" + durability.maxDurability]);
        equipmentInventory.setEquipment(EquipmentSlot.Mainhand, itemSlotMainHand);
      }
    }
  }
});

world.afterEvents.itemUse.subscribe((data) => {
  const { source, itemStack } = data;
  let equipmentInventory = source.getComponent(EntityComponentTypes.Equippable);
  let durability = itemStack.getComponent("durability");
  if (itemStack.typeId.includes("xp_book")) {
    if (source.isSneaking) {
      if ((durability.maxDurability - durability.damage) <= 0) {
        let xpToRepair = Math.min(source.level, durability.maxDurability);
        durability.damage -= xpToRepair;
        source.addLevels(-xpToRepair);
      } else {
        let halfMaxDurability = durability.maxDurability / 2;
        let xpToRepair = Math.min(source.level, halfMaxDurability, (durability.maxDurability - durability.damage));
        durability.damage -= xpToRepair;
        source.addLevels(-xpToRepair);
      }
    } else {
      let xpToAdd = durability.maxDurability - durability.damage;
      source.addLevels(xpToAdd);
      durability.damage += xpToAdd;
    }
    itemStack.setLore(["\xa7bxp: " + (durability.maxDurability - durability.damage) + "/" + durability.maxDurability]);
    equipmentInventory.setEquipment(EquipmentSlot.Mainhand, itemStack);
  }
});

system.afterEvents.scriptEventReceive.subscribe(async data => {
  try {
    const { sourceEntity: player, message, id } = data;
    if (id === "waystone:click") {
      let block = player.getBlockFromViewDirection()?.block;
      if (message === "fake" && block) {
        block.location.y--;
        block = world.getDimension(block.dimension.id || "overworld").getBlock(block.location);
      }
      if (block?.hasTag("waystone")) {
        if (block.hasTag("waystoneSetting")) {
          const dimensionId = block.dimension.id.split(":")[1];
          const waystoneTag = `waystone:${dimensionId}:${block.location.x}:${block.location.y}:${block.location.z}`;
          if (block.hasTag(waystoneTag)) {
            await displayWaystones(player);
          } else {
            const modalForm = new ModalFormData()
              .title("Configure Waystone")
              .textField("Set Name", "Enter a name for the waystone");
            const result = await modalForm.show(player);
            if (result.formValues) {
              let nameway = result.formValues[0].replace(/ /g, "_").replace(/:/g, " ");
              const existingWaystones = player.getTags().filter(tag => tag.startsWith("waystone:"));
              const isDuplicate = existingWaystones.some(tag => tag.includes(`waystone:${nameway}:`));
              if (isDuplicate) {
                player.sendMessage("A waystone with this name already exists. Please choose a different name.");
              } else {
                const { x, y, z } = block.location;
                const newWaystoneTag = `waystone:${nameway}:${dimensionId}:${x}:${y}:${z}`;
                const currentWaystoneNameTag = `currentWaystoneName:${nameway}`;
                player.getTags().forEach(tag => {
                  if (tag.startsWith("currentWaystoneName:")) {
                    player.removeTag(tag);
                  }
                });
                player.addTag(newWaystoneTag);
                block.setPermutation(BlockPermutation.resolve(block.typeId, { "waystone:use": true }));
                block.addTag(waystoneTag);
                player.addTag(currentWaystoneNameTag);
              }
            }
          }
        }
      }
    }
  } catch (error) {
    console.error("Error processing waystone click:", error);
  }
});

async function displayWaystones(player) {
  try {
    const ways = [];
    const GameMode = getGameMode(player);
    let block = player.getBlockFromViewDirection()?.block;
    if (block?.typeId === "waystone:fake_block") {
      block.location.y--;
      block = world.getDimension(block.dimension.id || "overworld").getBlock(block.location);
    }
    const form = new ActionFormData().title("Select a place to teleport");
    const dimension = player.dimension;
    const dimName = dimension.id.split(":")[1];
    player.getTags().forEach(tag => {
      if (tag.startsWith("waystone:")) {
        const waypoint = tag.replace(/_/g, " ").split(":");
        const way = {
          dimension: waypoint[waypoint.length - 4],
          x: parseInt(waypoint[waypoint.length - 3]),
          y: parseInt(waypoint[waypoint.length - 2]),
          z: parseInt(waypoint[waypoint.length - 1])
        };
        ways.push(way);
        const distance = calcDistance(player.location, way);
        const xpCost = `${Math.ceil((distance * 4) / 20)} XP`;
        form.button(`${waypoint[waypoint.length - 5]} [${xpCost}]`);
      }
    });
    if (ways.length < 1) {
      form.body("You don't have any waystone.");
      form.button("OK");
      await form.show(player);
      return;
    }
    const result = await form.show(player);
    if (!result.canceled) {
      const way = ways[result.selection];
      const distance = calcDistance(player.location, way);
      const xpCost = Math.ceil((distance * 4) / 20);
      if (GameMode !== "creative") {
        if (player.level >= xpCost) {
          player.addLevels(-xpCost);
          await world.getDimension(way.dimension).runCommandAsync(`tp ${player.name} ${way.x} ${way.y} ${way.z}`);
        } else {
          player.sendMessage(`You need ${xpCost} XP to use the waystone.`);
        }
      } else {
        await world.getDimension(way.dimension).runCommandAsync(`tp ${player.name} ${way.x} ${way.y} ${way.z}`);
      }
    }
  } catch (error) {
    console.error(error);
  }
}

world.afterEvents.playerBreakBlock.subscribe(async ({ player, brokenBlockPermutation, block }) => {
  try {
    const dimension = block.dimension;
    const dimensionId = dimension && dimension.id ? dimension.id : "overworld";
    const dimensionInstance = world.getDimension(dimensionId);
    await dimensionInstance.runCommandAsync("kill @e[type=item, name=waystone:fake_block]");
    await dimensionInstance.runCommandAsync("clear @a[hasitem={item=waystone:fake_block}] waystone:fake_block");
    const namewayTags = player.getTags().filter(tag => tag.startsWith("currentWaystoneName:"));
    if (namewayTags.length > 0) {
      namewayTags.forEach(namewayTag => {
        const nameway = namewayTag.split(":")[1];
        const blockLocationTag = `waystone:${nameway}:${dimensionId.split(":")[1]}:${block.location.x}:${block.location.y}:${block.location.z}`;
        let shouldRemoveNamewayTag = false;
        player.getTags().forEach(tag => {
          if (tag.includes(blockLocationTag)) {
            player.removeTag(tag);
            shouldRemoveNamewayTag = true;
          }
        });
        if (shouldRemoveNamewayTag) {
          player.removeTag(namewayTag);
        }
      });
    }
  } catch (error) {
    console.error("Error in playerBreakBlock event:", error);
  }
});

world.afterEvents.itemUse.subscribe(async ({ itemStack: item, source: player }) => {
  if (item.typeId === "waystone:warp_stone" || item.typeId === "waystone:warp_scroll") {
    const t = await displayWaystones(player);
    if (!t?.cancel) {
      const equippable = player.getComponent(EntityComponentTypes.Equippable);
      const mainHandItem = equippable.getEquipment(EquipmentSlot.Mainhand);
      if (item.typeId === "waystone:warp_stone") {
        const durability = mainHandItem.getComponent("durability");
        if ((durability.damage + 10) >= durability.maxDurability) {
          await player.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 air");
          return;
        }
        durability.damage += 10;
        mainHandItem.getComponent("cooldown").startCooldown(player);
        equippable.setEquipment(EquipmentSlot.Mainhand, mainHandItem);
      } else {
        await player.runCommandAsync("clear @s waystone:warp_scroll 0 1");
        equippable.setEquipment(EquipmentSlot.Mainhand, item);
      }
    }
  }
});

world.afterEvents.playerBreakBlock.subscribe((eventData) => {
  const { block, brokenBlockPermutation, dimension } = eventData;
  let player = eventData.player;
  const entity = dimension.getEntitiesAtBlockLocation(block.location).find((entity) => {
    return entity.typeId === "mhqstudios:storage_drawers.container";
  });
  if (!entity) return;
  const capacityObjective = world.scoreboard.getObjective("capacity");
  if (!capacityObjective) return;
  const capacity = capacityObjective.getScore(entity.scoreboardIdentity);
  if (brokenBlockPermutation.hasTag("drawers")) {
    entity.kill();
    if (capacity > 0) {
      player.runCommandAsync(`give @s ${entity.getTags()[0]} ${capacity}`);
    }
  }
});

world.afterEvents.playerInteractWithBlock.subscribe(async (eventData) => {
  try {
    const block = eventData.block;
    const player = eventData.player;
    if (!block.hasTag("drawers")) return;

    const item = eventData.itemStack;
    const dimension = block.dimension;
    const entities = dimension.getEntitiesAtBlockLocation(block.location);
    const entity = entities.find((entity) => entity.typeId === "mhqstudios:storage_drawers.container");
    if (!entity) return;

    const objectives = ['capacity', 'capacitytwo'];
    for (const objective of objectives) {
      await addScoreObjectives(entity, objective);
      await addScoreboard(entity, objective, 0);
    }

    const capacityObjective = world.scoreboard.getObjective("capacity");
    const capacityTwoObjective = world.scoreboard.getObjective("capacitytwo");
    if (!capacityObjective || !capacityTwoObjective) return;

    const capacity = capacityObjective.getScore(entity.scoreboardIdentity) || 0;
    const capacitytwo = capacityTwoObjective.getScore(entity.scoreboardIdentity) || 0;
    if (capacity >= capacitytwo) return;

    if (!player.isSneaking()) {
      const tags = entity.getTags();
      if (tags.length === 0) {
        if (!BlockTypes.get(item.typeId) && item.typeId !== "mhqstudios:storage_drawers.drawer_capacity_upgrade") {
          await handleNonBlockItem(entity, player, item);
        } else if (BlockTypes.get(item.typeId) && !ignoreBlock.includes(item.typeId)) {
          await handleBlockItem(entity, player, item);
        } else if (BlockTypes.get(item.typeId) && ignoreBlock.includes(item.typeId)) {
          await handleIgnoredBlockItem(entity, player, item);
        }
      } else {
        await handleExistingTagItem(entity, player, item, tags);
      }
    } else {
      await handleSneakingPlayer(player, entity, block, capacity, capacitytwo);
    }
  } catch (error) {}
});

async function handleNonBlockItem(entity, player, item) {
  await entity.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 ${item.typeId}`);
  await player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
  await entity.runCommandAsync(`tag @s add ${item.typeId}`);
  await entity.runCommandAsync(`scoreboard players add @s capacity ${item.amount}`);
}

async function handleBlockItem(entity, player, item) {
  await entity.runCommandAsync(`replaceitem entity @s slot.weapon.offhand 0 ${item.typeId}`);
  await player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
  await entity.runCommandAsync(`tag @s add ${item.typeId}`);
  await entity.runCommandAsync(`scoreboard players add @s capacity ${item.amount}`);
}

async function handleIgnoredBlockItem(entity, player, item) {
  await entity.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 ${item.typeId}`);
  await player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
  await entity.runCommandAsync(`tag @s add ${item.typeId}`);
  await entity.runCommandAsync(`scoreboard players add @s capacity ${item.amount}`);
}

async function handleExistingTagItem(entity, player, item, tags) {
  if (item.typeId && item.typeId !== "mhqstudios:storage_drawers.drawer_capacity_upgrade") {
    await entity.runCommandAsync(`execute if entity @p[hasitem={item=${tags[0]},location=slot.weapon.mainhand}] run scoreboard players add @s capacity ${item.amount}`);
    await player.runCommandAsync(`replaceitem entity @s[hasitem={item=${tags[0]},location=slot.weapon.mainhand}] slot.weapon.mainhand 0 air`);
  } else if (item.typeId === "mhqstudios:storage_drawers.drawer_capacity_upgrade") {
    await entity.runCommandAsync(`scoreboard players add @s capacitytwo 2176`);
    if (item.amount > 1) {
      await player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 mhqstudios:storage_drawers.drawer_capacity_upgrade ${item.amount - 1}`);
    } else {
      await player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
    }
  }
}

async function handleSneakingPlayer(player, entity, block, capacity, capacitytwo) {
  const form = new ModalFormData();
  const name = nameDrawers[block.typeId].name;
  form.title(`${name}`);
  form.textField(`%total_amount.text ${capacity}/${capacitytwo}\n%select_quantity.text`, 'ex.:1, 2, 3,...');
  const result = await form.show(player);
  if (!result.isCanceled) {
    const text = parseInt(result.formValues[0]);
    if (text && text > 0 && capacity >= text) {
      await player.runCommandAsync(`give @s ${entity.getTags()[0]} ${text}`);
      await entity.runCommandAsync(`scoreboard players remove @s capacity ${text}`);
    }
  }
}

system.afterEvents.scriptEventReceive.subscribe(async (eventData) => {
  if (eventData.id !== "storage_drawers:remove") return;
  const entity = eventData.sourceEntity;
  const upLocation = { x: entity.location.x, y: entity.location.y + 1, z: entity.location.z };
  const upBlock = entity.dimension.getBlock(upLocation);
  const inventory = upBlock.getComponent("minecraft:inventory")?.container;
  const objectives = ['capacity', 'capacitytwo'];
  for (const objective of objectives) {
    await addScoreObjectives(entity, objective);
    await addScoreboard(entity, objective, 0);
  }
  const capacityObjective = world.scoreboard.getObjective("capacity");
  const capacityTwoObjective = world.scoreboard.getObjective("capacitytwo");
  const capacity = capacityObjective ? capacityObjective.getScore(entity.scoreboardIdentity) : 0;
  const capacitytwo = capacityTwoObjective ? capacityTwoObjective.getScore(entity.scoreboardIdentity) : 0;
  if (entity.getTags().length > 0 && capacity === 0) {
    entity.removeTag(entity.getTags()[0]);
    await entity.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
    await entity.runCommandAsync(`replaceitem entity @s slot.weapon.offhand 0 air`);
  }
  if (upBlock?.typeId === "minecraft:hopper" && inventory) {
    for (let i = 0; i < inventory.size; i++) {
      let hopperSlot = inventory.getItem(i);
      if (hopperSlot && hopperSlot.typeId === entity.getTags()[0] && capacity < capacitytwo) {
        if (hopperSlot.amount > 1) {
          hopperSlot.amount--;
        } else {
          hopperSlot = null;
        }
        inventory.setItem(i, hopperSlot);
        await entity.runCommandAsync(`scoreboard players add @s capacity 1`);
      }
    }
  }
});

world.afterEvents.playerPlaceBlock.subscribe(data => {
  const player = data.player;
  const block = data.block;
  const { x, y, z } = block.location;
  let gameMode = getGameMode(player);
  const score = world.scoreboard.getObjective('building').getScore(player.scoreboardIdentity);
  if (gameMode != "creative") {
    if ((block.typeId === "minecraft:anvil" || block.typeId === "minecraft:enchanting_table") && score <= 12) {
      player.runCommandAsync(`setblock ${x} ${y} ${z} air`);
      block.dimension.spawnItem(new ItemStack(block.typeId, 1), { x, y, z });
    }
  }
});

world.beforeEvents.itemUseOn.subscribe(data => {
  const { block } = data;
  const player = data.source;
  const item = data.itemStack;
  const { x, y, z } = block.location;
  if (item.typeId == "allainmc:soulkey") {
    if (block.typeId == "allainmc:soulcubeundead") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/amalgalich.phase_1`);
    }
    if (block.typeId == "allainmc:soulcubeaberrant") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/asmodeus.phase_1`);
    }
    if (block.typeId == "allainmc:soulcubedemonic") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/rahovart.phase_1`);
    }
  }
  if (item.typeId == "allainmc:soulkeyemerald") {
    if (block.typeId == "allainmc:soulcubeundead") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/amalgalich.phase_2`);
    }
    if (block.typeId == "allainmc:soulcubeaberrant") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/asmodeus.phase_2`);
    }
    if (block.typeId == "allainmc:soulcubedemonic") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/rahovart.phase_2`);
    }
  }
  if (item.typeId == "allainmc:soulkeydiamond") {
    if (block.typeId == "allainmc:soulcubeundead") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/amalgalich.phase_3`);
    }
    if (block.typeId == "allainmc:soulcubeaberrant") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/asmodeus.phase_3`);
    }
    if (block.typeId == "allainmc:soulcubedemonic") {
      player.runCommandAsync(`execute if block ${x} ${y + 1} ${z} obsidian run execute if block ${x} ${y - 1} ${z} obsidian run execute if block ${x} ${y - 2} ${z} obsidian run execute if block ${x + 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x + 2} ${y} ${z + 2} obsidian run execute if block ${x + 2} ${y - 1} ${z + 2} obsidian run execute if block ${x + 2} ${y - 2} ${z + 2} obsidian run execute if block ${x - 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x - 2} ${y} ${z - 2} obsidian run execute if block ${x - 2} ${y - 1} ${z - 2} obsidian run execute if block ${x - 2} ${y - 2} ${z - 2} obsidian run execute if block ${x + 2} ${y + 1} ${z - 2} diamond_block run execute if block ${x + 2} ${y} ${z - 2} obsidian run execute if block ${x + 2} ${y - 1} ${z - 2} obsidian run execute if block ${x + 2} ${y - 2} ${z - 2} obsidian run execute if block ${x - 2} ${y + 1} ${z + 2} diamond_block run execute if block ${x - 2} ${y} ${z + 2} obsidian run execute if block ${x - 2} ${y - 1} ${z + 2} obsidian run execute if block ${x - 2} ${y - 2} ${z + 2} obsidian run function boss/rahovart.phase_3`);
    }
  }
});